
#include <hmg.ch>
#include "hfcl.ch"
#include "GeneraTXT.prg"
#include "MiraX.prg"

Function Main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT
  RDDSETDEFAULT( "DBFCDX" )

  SET CODEPAGE TO SPANISH 
*---------------------------------------------------------------------*
  SET DELETE ON
  SET DECIMALS TO 2
  SET FIXED ON
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO "dd/mm/yyyy"
  SET ESCAPE ON
  SET NAVIGATION EXTENDED
  SET BROWSESYNC OFF
*----------------------------------------------------------------------*

 PRIVATE  cNombre ,  numero ,  cNUmero ,     horaS , aChecbo  
 PRIVATE   nValor ,  ComasX ,  nValorX ,  nValorXF ,    pext ,  provax
 PRIVATE  AnValor , AComasX , AnValorX , AnValorXF ,   Apext , Aprovax
 PRIVATE  BnValor , BComasX , BnValorX , BnValorXF ,   Bpext , Bprovax
 PRIVATE  CnValor , CComasX , CnValorX , CnValorXF ,   Cpext , Cprovax
 PRIVATE  DnValor , DComasX , DnValorX , DnValorXF ,   Dpext , Dprovax

*---------------------------------------------------------------------*

  DEFINE WINDOW main                              ;
       AT 000,000                                 ;
       WIDTH  320 HEIGHT 410                      ; 
       ICON "Logo"                                ;  
       TITLE 'HMG HPDF PRINT Sample Factura -> '  ;
       NOMINIMIZE NOMAXIMIZE   TOPMOST            ;
       MAIN                                       ;
       ON INIT OpenTables()                       ;
       ON PAINT Proc_ON_PAINT ()                  ;  // <------- Color Gris 
       ON INTERACTIVECLOSE ( MsgStop('Not Allowed', 'Attention !!!') , .F. )                                       

       ON KEY ESCAPE ACTION FinalProgram()       

    @ 056,073 CHECKBOX  Check_1 CAPTION ""  WIDTH 14 HEIGHT 14 
                     
    @ 055,096 LABEL Label_2 VALUE 'Fichero Respaldo TxT ?'WIDTH 140 HEIGHT 15 ;
                            FONT "Arial" SIZE 10 ITALIC BACKCOLOR { 212,212,212}                     
    DEFINE BUTTON Button_01
        ROW    090  
        COL    070  
        WIDTH  165
        HEIGHT 055
        CAPTION 'Factura Pdf'
        ACTION pdf_create()     
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Acept"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen01.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

      
    DEFINE BUTTON Button_02
        ROW    160  
        COL    070  
        WIDTH  165
        HEIGHT 055
        CAPTION 'View Database'
        ACTION MIRAX()
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "View"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen02.bmp"
        PICTALIGNMENT LEFT
    END BUTTON
        
    DEFINE BUTTON Button_03
        ROW    230  
        COL    070 
        WIDTH  165
        HEIGHT 055
        CAPTION 'Exit'
        ACTION FinalProgram()            
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Exit"
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        MULTILINE .F.
        PICTURE "resource\Imagen03.bmp"
        PICTALIGNMENT LEFT
    END BUTTON

  main.Check_1.value:= .T.

  end window

       SETWINDOWCURSOR ( main.Button_01.Handle, "resource\finger.cur")

   main.center
   main.activate
 
Return

*------------------------------------------*
 Function FinalProgram()
*------------------------------------------*

 IF MsgYesNo("Do you want to finish the program ?","Atention !!!") = .T.
       CLOSE DATABASES
       main.Release
    Return .T.
 EndIf

*---------------------------------------------------*
Function OpenTables()
*---------------------------------------------------*

   SELECT 1
   USE MESES
   SELECT 2
   USE VENTAS new

Return .T.

*---------------------------------------------------*
function pdf_create()
*---------------------------------------------------*
  
   PRIVATE pagina:= 0
   PRIVATE horaS
   PRIVATE reng  := 0
   PRIVATE TOT   := 0.00
   PRIVATE F_Mus := 123       //  <------- Inicio Linia Facturacin

*----------------------------------------------------*

  CLOSE DATABASES
  USE MESES
  SET CENTURY ON
  SET DATE FRENCH
  IF ULTIMO_REC >= 99999
     REPLACE ULTIMO_REC WITH 0
  ENDIF
  CLOSE DATABASES
  USE MESES
   SET CENTURY ON
   SET DATE FRENCH
    IF .NOT. ULTIMO_REC = 1
      *** ?? CHR(7)
       APPEND BLANK
       REPLACE ULTIMO_REC WITH ULTIMO_REC+0
       REPLACE FECHA_FACT WITH DTOC(DATE())
       REPLACE HORA WITH TIME() 
   ENDIF
  CLOSE DATABASES
  USE MESES
  REPLACE ULTIMO_REC WITH ULTIMO_REC+1
  DELETE FOR ULTIMO_REC = 0
  PACK
  REPLACE FECHA_FACT WITH DTOC(DATE())
  REPLACE HORA WITH TIME() 

 *------------------------------------------------------------------------------*
 *  Respaldo de Seguridad ------------------------------------------------------*
 *------------------------------------------------------------------------------*

  CLOSE DATABASES
  USE MESES
  numero:=ALLTRIM(STR(ULTIMO_REC))
  cNumero:=RTRIM(STRTRAN(numero,"/","_",1,len(numero)))
  cNombre:="Facturas_PdF\"+"Factura"+"_"+cNumero +".pdf"
  CLOSE DATABASES

*---------------------------------------------------------------------------------------------*

   SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4 

*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*

 * SET HPDFDOC ENCODING TO "WinAnsiEncoding"

   SET HPDFDOC ENCODING TO "CP1252"  

*---------------------------------------------------------------------------------------------*

   START HPDFDOC
              
            START HPDFPAGE
		
            pagina:=1

*------------------------------------------------ Cuadro General ------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1  
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1                  

*----------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------*

*------------------------------------------------ Recuadro Empresa ----------------------------*

     @ 018,018 HPDFPRINT RECTANGLE TO 056, 146 PENWIDTH 2 COLOR { 051, 051, 051 } FILLED ROUNDED CURVE 1   
     @ 016,016 HPDFPRINT RECTANGLE TO 054, 144 PENWIDTH 2 COLOR { 132, 193, 255 } FILLED ROUNDED CURVE 1  

*----------------------------------------------------------------------------------------------*  

     @ 021,020 HPDFPRINT IMAGE "Resource\Logo.png" width 28 height 29  

     SELECT 1
     USE VENTAS
    
     @ 026,055 HPDFPRINT ALLTRIM(VENTAS->NOMBR) + SPACE(1)+"S.L." FONT "Times-Roman" SIZE 12 ITALIC
     @ 030,055 HPDFPRINT VENTAS->DIRECCIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 034,055 HPDFPRINT VENTAS->(LTRIM(CODIG))+space(1)+VENTAS->POBLACIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 038,055 HPDFPRINT VENTAS-> PROVI FONT "Times-Roman" SIZE 12 ITALIC
     @ 042,055 HPDFPRINT "Telf.:" + space(2) + VENTAS->(LTRIM(TELEFON))+SPACE(6)+"Fax.:"+space(2)+VENTAS->(LTRIM(FAXX) ) FONT "Times-Roman" SIZE 12 ITALIC
     @ 046,055 HPDFPRINT "NIF :"  + space(2) + VENTAS->(LTRIM(NI)) + space(2) + VENTAS->(ALLTRIM(MAIL)) FONT "Times-Roman" SIZE 12 ITALIC
 
*-----------------------------------------------------------------------------------------------*

     @ 062,015  HPDFPRINT RECTANGLE TO 72, 197  ROUNDED CURVE 1        
 
     SELECT 1
     USE VENTAS

     @ 066,020 HPDFPRINT "Cdigo Cliente:"+SPACE(13)+ ALLTRIM(STR(VENTAS->NUM_CLI)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 070,020 HPDFPRINT "NIF: "+SPACE(4)+LTRIM(VENTAS->NIF)+SPACE(6)+"Telf.: "+SPACE(1)+LTRIM(VENTAS->TELEFONO)  FONT "Times-Roman" SIZE 12 ITALIC

     SELECT 2
     USE MESES

     @ 066,145 HPDFPRINT ALLTRIM( STR(MESES->ULTIMO_REC)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,120 HPDFPRINT "Factura n.:" FONT "Times-Roman" SIZE 12 ITALIC

     horaS := LEFT(MESES->HORA, 5) 

     @ 070,145 HPDFPRINT ALLTRIM( MESES->FECHA_FACT) + SPACE(4) + ALLTRIM(horas) FONT "Times-Roman" SIZE 12 ITALIC  
     @ 070,120  HPDFPRINT "Fecha Fact.:" FONT "Times-Roman" SIZE 12 ITALIC 
  
*------------------------------------------------------------------------------------------------*

     @ 076,117 HPDFPRINT RECTANGLE TO 098, 197 PENWIDTH 0.1  ROUNDED CURVE 1       

     SELECT 1
     USE VENTAS
  
     @ 082,120 HPDFPRINT ALLTRIM(VENTAS->R_SOCIAL) FONT "Times-Roman" SIZE 12 ITALIC
     @ 086,120 HPDFPRINT "C/"+SPACE(1)+ALLTRIM(VENTAS->DIRECCION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 090,120 HPDFPRINT  LTRIM(VENTAS->CD_POSTAL)+SPACE(1)+ALLTRIM(VENTAS->POBLACION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 094,120 HPDFPRINT ALLTRIM(VENTAS->PROVINCIA) FONT "Times-Roman" SIZE 12 ITALIC

*---------------------------- Recuadro y Nombre de Productos ------------*

 
     @ 101,015 HPDFPRINT RECTANGLE TO 109, 197  ROUNDED CURVE 1       

     @ 106,020 HPDFPRINT  "Cdigo"+space(38)+"Nombre Artculo"+SPACE(31)+"Precio"+SPACE(10)+"Cantidad"+SPACE(12)+"Total" FONT "Times-Roman" SIZE 12 ITALIC  

 *---------------------------  RECTANGLE Productos  ---------------------*


     @ 118,015 HPDFPRINT RECTANGLE TO 267, 197  ROUNDED CURVE 1       

     @ 118,032 HPDFPRINT LINE TO 267, 032 PENWIDTH 0.1 
     @ 118,128 HPDFPRINT LINE TO 267, 128 PENWIDTH 0.1 
     @ 118,153 HPDFPRINT LINE TO 267, 153 PENWIDTH 0.1 
     @ 118,174 HPDFPRINT LINE TO 267, 174 PENWIDTH 0.1 

*------------------------------------------------------------------------*

    DO WHILE !ventas->(EOF())

        reng=reng+1

*------------------------ Referencia --------------------------*

           PRIVATE Arefe , Brefe

           Arefe   := ventas->REF

           Brefe := ALLTRIM(STR(Arefe))           

 *------------------------ VENTA ------------------------------*
           PRIVATE mVenta , pVenta

           mVenta  := ventas->VENTA  

           pVenta  := ALLTRIM(STR(mVenta))           
 
 *---------- TRANSFORM ------ Para ---->  PVENTA_E  ----------*

           nValor   := ventas->PVENTA_E

           ComasX   := TRANSFORM(nValor,"9,999,999,999.99")

           nValorX  := Strtran( ComasX ,".", "," )

           nValorXF := Strtran( STR(nValor),".", "," )

           pext     := ALLTRIM(STR(nValor))

           IF LEN(pext) >=   9 
               provax := STUFF(nValorXF, 8, 0, ".")   
              ELSE
               provax := nValorXF
           ENDIF


*-------- TRANSFORM ----- Para -->  PVENTA_E*VENTA ----------*

           AnValor   := nValor*mVenta      //  <--- PVENTA_E * VENTA

           AComasX   := TRANSFORM(AnValor,"9,999,999,999.99")

           AnValorX  := Strtran( AComasX ,".", "," )

           AnValorXF := Strtran( STR(AnValor),".", "," )

           Apext     := ALLTRIM(STR(AnValor))

           IF LEN(Apext) >= 7
              Aprovax := STUFF(AnValorXF, 8, 0, ".")
             ELSE
              Aprovax := AnValorXF
           ENDIF

*------------------------------------------------------------------------*
*----------------------- Facturacin Productos --------------------------*

*----------------------------------- REF --------------------------------*

         Brefe := ALLTRIM(STR(Arefe))     

         IF LEN(Brefe) = 7  
            @ F_Mus, 12 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          IF LEN(Brefe) = 6 
            @ F_Mus, 13 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          IF LEN(Brefe) = 5  
            @ F_Mus, 14 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          IF LEN(Brefe) = 4  
            @ F_Mus, 15 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          IF LEN(Brefe) = 3  
            @ F_Mus, 16 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          IF LEN(Brefe) = 2  
            @ F_Mus, 17 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
         IF LEN(Brefe) = 1 
            @ F_Mus, 18 HPDFPRINT RTRIM( ventas->(STR(REF))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
          
*------------------------------------- NOM_ART --------------------------*

         @ F_Mus, 36 HPDFPRINT LTRIM( ventas->NOM_ART) FONT "Times-Roman" SIZE 12 ITALIC
          
*------------------------------------------------------------------------*
 
*------------------------------------------------------------------------* 
 
*-------------------------- Precio Artculo------------------------------*

         IF LEN(pext) = 7 
            @ F_Mus,130 HPDFPRINT provax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

         IF LEN(pext) = 6
            @ F_Mus,131 HPDFPRINT provax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

         IF LEN(pext) = 5
            @ F_Mus,132 HPDFPRINT provax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

         IF LEN(pext) = 4
            @ F_Mus,133 HPDFPRINT provax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

         IF LEN(pext) = 3
            @ F_Mus,134 HPDFPRINT provax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

*--------------------------------------- Cantidad Vendida --------------------------*

         IF LEN(pVenta) = 5 
            @ F_Mus,156 HPDFPRINT RTRIM( ventas->(STR(VENTA))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF  
      
         IF LEN(pVenta) = 4 
            @ F_Mus,157 HPDFPRINT RTRIM( ventas->(STR(VENTA))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF        
  
         IF LEN(pVenta) = 3
            @ F_Mus,158 HPDFPRINT RTRIM( ventas->(STR(VENTA))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF        
  
         IF LEN(pVenta) = 2
            @ F_Mus,159 HPDFPRINT RTRIM( ventas->(STR(VENTA))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF        
   
         IF LEN(pVenta) = 1
            @ F_Mus,160 HPDFPRINT RTRIM( ventas->(STR(VENTA))) FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF        
*----------------------------------------------------------------------------*  

*------------------------( Precio * Cantidad )= Total -----------------------*

         IF LEN(Apext) = 10
            @ F_Mus,169 HPDFPRINT Aprovax   FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 

         IF LEN(Apext) = 9
            @ F_Mus,170 HPDFPRINT Aprovax   FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 

         IF LEN(Apext) = 8           
            @ F_Mus,171 HPDFPRINT Aprovax   FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

         IF LEN(Apext) = 7           
            @ F_Mus,172 HPDFPRINT Aprovax  FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF   

         IF LEN(Apext) = 6           
            @ F_Mus,174 HPDFPRINT Aprovax  FONT "Times-Roman" SIZE 12 ITALIC 
         ENDIF  

         IF LEN(Apext) = 5
            @ F_Mus,175 HPDFPRINT Aprovax  FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF  

         IF LEN(Apext) = 4           
            @ F_Mus,176 HPDFPRINT Aprovax  FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF 
 
         IF LEN(Apext) = 3
            @ F_Mus,177 HPDFPRINT Aprovax  FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF  

*----------------------------------------------------------------------------*


       TOT = TOT+PVENTA_E*VENTA

*--------- TRANSFORM ---- Para -->  TOT----------*

         BnValor   := TOT

         BComasX   := TRANSFORM(BnValor,"9,999,999,999.99")

         BnValorX  := Strtran( BComasX ,".", "," )

         BnValorXF := Strtran( Str(BnValor),".", "," )

         Bpext     := ALLTRIM(STR(BnValor))

         IF LEN(Bpext) >= 7
            Bprovax := STUFF(BnValorXF, 8, 0, ".")
           ELSE
            Bprovax := BnValorXF
         ENDIF


*-------------------------------n pagina  ------------------------*

        @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------------------------*

          F_Mus=F_Mus+4

        ventas->(dbskip())

          IF F_Mus > ( 123+140)   // <--------------- Salto de Pgina

             pagina:=pagina+1
  
*------------------------------- Total Suma y Sigue ---------------*
         IF LEN(Bpext) = 9
               @ 277,170 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 8
               @ 277,171 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

         IF LEN(Bpext) = 7
               @ 277,172 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

         IF LEN(Bpext) = 6
               @ 277,174 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

         IF LEN(Bpext) = 5
               @ 277,176 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC   
         ENDIF

         IF LEN(Bpext) = 4
               @ 277,176 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

         IF LEN(Bpext) = 3
               @ 277,178 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC
         ENDIF

*-----------------------------------------------------------------*

         @ 277, 129 HPDFPRINT "Suma y Sigue    " FONT "Times-Roman" SIZE 12 ITALIC 


       END HPDFPAGE  
*-----------------------------------------------------------------*

      reng:=0

      START HPDFPAGE
     
*--------------------------------------------------- Cuadro General ---------------------------------------------------*

     @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1  ROUNDED CURVE 1         
     @ 007,007  HPDFPRINT RECTANGLE TO 290, 204             ROUNDED CURVE 1       

*----------------------------------------------------------------------------------------------------------------------*
*----------------------------------------------------------------------------------------------------------------------*

*--------------------------------------------------- Recuadro Empresa -------------------------------------------------*

     @ 018,018 HPDFPRINT RECTANGLE TO 056, 146 PENWIDTH 2 COLOR { 051, 051, 051 } FILLED ROUNDED CURVE 1      
     @ 016,016 HPDFPRINT RECTANGLE TO 054, 144 PENWIDTH 2 COLOR { 132, 193, 255 } FILLED ROUNDED CURVE 1  

*-----------------------------------------------------------------------------------------------------------------------*  

     @ 021,020 HPDFPRINT IMAGE "Resource\Logo.png" width 28 height 29  

     @ 026,055 HPDFPRINT ALLTRIM(VENTAS->NOMBR) + SPACE(1)+"S.L." FONT "Times-Roman" SIZE 12 ITALIC
     @ 030,055 HPDFPRINT VENTAS->DIRECCIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 034,055 HPDFPRINT VENTAS->(LTRIM(CODIG))+space(1)+VENTAS->POBLACIO FONT "Times-Roman" SIZE 12 ITALIC
     @ 038,055 HPDFPRINT VENTAS-> PROVI FONT "Times-Roman" SIZE 12 ITALIC
     @ 042,055 HPDFPRINT "Telf.:" + space(2) + VENTAS->(LTRIM(TELEFON))+SPACE(6)+"Fax.:"+space(2)+VENTAS->(LTRIM(FAXX) ) FONT "Times-Roman" SIZE 12 ITALIC
     @ 046,055 HPDFPRINT "NIF :"  + space(2) + VENTAS->(LTRIM(NI)) + space(2) + VENTAS->(ALLTRIM(MAIL)) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------------------------------------------------------------------------------*

     @ 062,015 HPDFPRINT RECTANGLE TO 72, 197 ROUNDED CURVE 1       

     @ 066,020 HPDFPRINT "Cdigo Cliente:"+SPACE(13)+ ALLTRIM(STR(VENTAS->NUM_CLI)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 070,020 HPDFPRINT "NIF: "+SPACE(4)+LTRIM(VENTAS->NIF)+SPACE(6)+"Telf.: "+SPACE(1)+LTRIM(VENTAS->TELEFONO)  FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,145 HPDFPRINT ALLTRIM( STR(MESES->ULTIMO_REC)) FONT "Times-Roman" SIZE 12 ITALIC
     @ 066,120 HPDFPRINT "Factura n.:" FONT "Times-Roman" SIZE 12 ITALIC

     horaS := LEFT(MESES->HORA, 5) 

     @ 070,145 HPDFPRINT ALLTRIM( MESES->FECHA_FACT) + SPACE(4) + ALLTRIM(horas) FONT "Times-Roman" SIZE 12 ITALIC  // <---  solo Hora y Minutos // ALLTRIM(HORA)  <-- Hora Completa         
     @ 070,120 HPDFPRINT "Fecha Fact.:" FONT "Times-Roman" SIZE 12 ITALIC 
  
*-------------------------------------------------------------------------------------------------------------------------*

     @ 076,117 HPDFPRINT RECTANGLE TO 098, 197 PENWIDTH 0.1 ROUNDED CURVE 1       

     @ 082,120 HPDFPRINT ALLTRIM(VENTAS->R_SOCIAL) FONT "Times-Roman" SIZE 12 ITALIC
     @ 086,120 HPDFPRINT "C/"+SPACE(1)+ALLTRIM(VENTAS->DIRECCION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 090,120 HPDFPRINT  LTRIM(VENTAS->CD_POSTAL)+SPACE(1)+ALLTRIM(VENTAS->POBLACION) FONT "Times-Roman" SIZE 12 ITALIC
     @ 094,120 HPDFPRINT ALLTRIM(VENTAS->PROVINCIA) FONT "Times-Roman" SIZE 12 ITALIC

*-------------------------------------------------- Recuadro y Nombre de Productos ---------------------------------------*

     @ 101,015 HPDFPRINT RECTANGLE TO 109, 197  ROUNDED CURVE 1       

     @ 106,020 HPDFPRINT "Cdigo"+space(38)+"Nombre Artculo"+SPACE(31)+"Precio"+SPACE(10)+"Cantidad"+SPACE(12)+"Total" FONT "Times-Roman" SIZE 12 ITALIC  
   
*-------------------------------------------------------- Total ----------------------------------------------------------*
        
         IF LEN(Bpext) = 9
               @ 115,170 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 8
               @ 115,171 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 7
               @ 115,172 HPDFPRINT Bprovax   FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 6
               @ 115,174 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 5
               @ 115,176 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC   
         ENDIF

         IF LEN(Bpext) = 4
               @ 115,176 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC  
          ENDIF

         IF LEN(Bpext) = 3
               @ 115,178 HPDFPRINT Bprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

*---------------------------------------------------------------------------------------------------------------------------*

        @ 115,129 HPDFPRINT  "Suma Anterior   " FONT "Times-Roman" SIZE 12 ITALIC  

*-----------------------------------------  RECTANGLE Productos  -----------------------------------------------------------*

        @ 118,015 HPDFPRINT RECTANGLE TO 267, 197  ROUNDED CURVE 1       

        @ 118,032 HPDFPRINT LINE TO 267, 032 PENWIDTH 0.1 
        @ 118,128 HPDFPRINT LINE TO 267, 128 PENWIDTH 0.1 
        @ 118,153 HPDFPRINT LINE TO 267, 153 PENWIDTH 0.1 
        @ 118,174 HPDFPRINT LINE TO 267, 174 PENWIDTH 0.1 

*---------------------------------------------------------------------------------------------------------------------------*
   
        F_Mus = 123

        endif
   ENDDO
   

   Ivax  = TOT * 21/100
   Totis = TOT + Ivax

 *--------------------------------------------------*
 *----------------- Para -->   Ivax ----------------*
 *--------------------------------------------------*

         CnValor   :=  Ivax

         CComasX   := TRANSFORM(CnValor,"9,999,999.99")

         CnValorX  := Strtran( CComasX ,".", "," )

         CnValorXF := Strtran( Str(CnValor),".", "," )

         Cpext     := ALLTRIM(STR(CnValor))

         IF LEN(Cpext) >= 7
            Cprovax := STUFF(CnValorXF, 8, 0, ".")
           ELSE
            Cprovax := CnValorXF
         ENDIF

 *--------------------------------------------------*
 *------------- Para -->    Totis ------------------*
 *--------------------------------------------------*

         DnValor   := Totis

         DComasX   := TRANSFORM(DnValor,"9,999,999,999.99")

         DnValorX  := Strtran( DComasX ,".", "," )

         DnValorXF := Strtran( Str(DnValor),".", "," )

         Dpext     := ALLTRIM(STR(DnValor))

         IF LEN(Dpext) >= 7
            Dprovax := STUFF(DnValorXF, 8, 0, ".") 
          ELSE
            Dprovax := DnValorXF
         ENDIF

*-------------------------------------------------------------------------------------------------------------------------*

        @ 269,122 HPDFPRINT RECTANGLE TO 283, 197 PENWIDTH 0.1  ROUNDED CURVE 1         

        @ 273,125 HPDFPRINT  "Base Imponible"+SPACE(2)+"" FONT "Times-Roman" SIZE 12 ITALIC  
        @ 277,125 HPDFPRINT  "I.V.A. 21 %" FONT "Times-Roman" SIZE 12 ITALIC  
        @ 281,125 HPDFPRINT  "Total Factura"+SPACE(6)+""  FONT "Times-Roman" SIZE 12 ITALIC  

 *--------------------------------------------------*
 *--------- Total = Suma ---------------------------*
 *--------------------------------------------------*

         IF LEN(Bpext) = 16
               @ 273,163 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 15
               @ 273,164 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF


         IF LEN(Bpext) = 14
               @ 273,165 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Bpext) = 13
               @ 273,166 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC    
         ENDIF

         IF LEN(Bpext) = 12
               @ 273,167 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 11
               @ 273,168 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC         
         ENDIF
         IF LEN(Bpext) = 10
               @ 273,169 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 9
               @ 273,170 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 8
               @ 273,171 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 7
               @ 273,172 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 6
               @ 273,174 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 5
               @ 273,175 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Bpext) = 4
               @ 273,176 HPDFPRINT Bprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         
*-------------------------------- Iva ---------------------------------------*
    
         IF LEN(Cpext) = 10       
               @ 277,169 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         IF LEN(Cpext) = 9      
               @ 277,170 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         IF LEN(Cpext) = 8       
               @ 277,171 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Cpext) = 7       
               @ 277,172 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         IF LEN(Cpext) = 6       
               @ 277,174 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         IF LEN(Cpext) = 5       
               @ 277,175 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         IF LEN(Cpext) = 4       
               @ 277,176 HPDFPRINT  Cprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF 
         
 *----------------------------------  Totis ------------------*
 
         IF LEN(Dpext) = 16
               @ 281,163 HPDFPRINT Dprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Dpext) = 15
               @ 281,164 HPDFPRINT Dprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
          IF LEN(Dpext) = 14
               @ 281,165 HPDFPRINT Dprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 13
               @ 280,166 HPDFPRINT Dprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF

         IF LEN(Dpext) = 12
               @ 281,167 HPDFPRINT Dprovax FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 11
               @ 281,168 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 10
               @ 281,169 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 9
               @ 281,170 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 8   
               @ 281,171 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 7
               @ 281,172 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 6
               @ 281,174 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 5
               @ 281,174 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
         IF LEN(Dpext) = 4
               @ 281,176 HPDFPRINT Dprovax  FONT "Times-Roman" SIZE 12 ITALIC  
         ENDIF
       
*------------------------------------------------------------*
         
      END HPDFPAGE  
                
    END HPDFDOC   

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*


 *---------------------------------------------------------*
 *------------- Fichero Copia Seguridad -------------------*
 *---------------------------------------------------------*

   ficherox = "Factura"+"_"+cNumero +".pdf"

   USE ventas
   numb   = NUM_CLI
   rsoc   = R_SOCIAL

   CLOSE DATABASES
   USE segury
   APPEND FROM MESES

   REPLACE NUM_CLI  WITH numb
   REPLACE R_SOCIAL WITH rsoc
   REPLACE NOM_FICH WITH ficherox
   REPLACE SUMA     WITH TOT
   REPLACE IVA      WITH Ivax
   REPLACE TOTAL    WITH Totis
   CLOSE DATABASES

*------------------------------------------------------------*
 
   IF msgYesNo( "Desea abrir el archivo generado por la impresion?","Atention!!!" )
                 CLOSE DATABASES
                 View_Pdf()
           *     Execute file cNombre  (opcional)
   ENDIF

*------------------------------------------------------------*

   aChecbo  := ( IIF( main.Check_1.Value,"True","False") )
   
   IF aChecbo = "True" 
            GeneraTXT()
            RETURN Nil

   ENDIF

RETURN Nil


*---------------------------------------*
FUNCTION  View_Pdf()
*---------------------------------------*

   DEFINE WINDOW Form_1       ;
      AT 0,0                  ;
      WIDTH  850              ;  
      HEIGHT 770              ;
      ICON "Logo"             ;  
      TITLE ficherox          ;
      NOMINIMIZE NOMAXIMIZE TOPMOST  ;        
      CHILD
   
      ON KEY ESCAPE ACTION Form_1.Release 

   END WINDOW


   @ 10,10 ACTIVEX Test       ;
      PARENT Form_1           ;
      WIDTH  840              ; 
      HEIGHT 760              ;
      PROGID "AcroPDF.PDF.1"  

   Form_1.Test.Object:src :=  GetCurrentFolder() + '\Facturas_PdF\' +  ficherox 

   Form_1.center
   Activate Window Form_1

   RETURN NIL

*-----------------------------------------------------------*
 FUNCTION Proc_ON_PAINT()  //  -> Courtesy of Javier Tovar
*-----------------------------------------------------------*

LOCAL hDC, BTstruct

hBitmap := BT_BitmapRelease() 

   hDC := BT_CreateDC ("main", BT_HDC_INVALIDCLIENTAREA, @BTstruct)
          BT_DrawGradientFillVertical (hDC, 0, 0, BT_ClientAreaWidth("main"), BT_ClientAreaHeight("main"), WHITE, BLACK)
          BT_DrawBitmap (hDC, 0, 0, 400, 200, BT_COPY, hBitmap)
          BT_DeleteDC (BTstruct)
RETURN

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*


















   